﻿@page "/"

@using HexWorld_IS.HexWorld
@using ReenforcementLearning
@using SkiaSharp
@using SkiaSharp.Views.Blazor
@using System.Numerics
@using Svg.Skia

<PageTitle>Hex-World</PageTitle>

@code{string px(float px) => $"{px}px";}

<div style="
  display: grid;
  grid-template-columns: @px(AgentViewWidth) @px(MainViewWidth);
  grid-template-rows: auto @px(MainViewHeight-AgentViewHeight-10) @px(AgentViewHeight);
  gap: 10px;
  padding: 10px;
">
    <h1>Hex-World</h1>

    <div style="display:flex; flex-direction: row; margin-top: auto">
    
        <label for="learning-rate">Lern-Rate</label> <input name="learning-rate" inputmode="numeric"/>
    </div>

    <div style="display: flex; flex-direction: column; 
width: @px(AgentViewWidth); ">
        <div>
            <table class="table" style="width: @px(AgentViewWidth)">
            <tr>
                <th>State</th>
                <th>q(a0)</th>
                <th>q(a1)</th>
                <th>q(a2)</th>
                <th>q(a3)</th>
                <th>q(a4)</th>
                <th>q(a5)</th>
            </tr>
        </table>
        <div style="overflow-y:scroll; width: @px(AgentViewWidth+100); height: @px(MainViewHeight-AgentViewHeight)">
            <table class="table" style="width: @px(AgentViewWidth); transform:translateY(-1.5rem)">
                <tr color>
                    <th>State</th>
                    <th>q(a0)</th>
                    <th>q(a1)</th>
                    <th>q(a2)</th>
                    <th>q(a3)</th>
                    <th>q(a4)</th>
                    <th>q(a5)</th>
                </tr>
                @if(agent is SarsaAgent<HexWorldAction, HexWorldPos> sarsaAgent)
                @foreach (var (pos, values) in sarsaAgent.QTable)
                {
                    <tr style="
                        background: @(agent?.CurrentState==pos?"#F9E79F":"white");
                        outline: @(hoveredFieldPos==pos?"solid black 1px":"none")
                        ">
                        <td>@($"({pos.r, 2}, {pos.dr, 2})")</td>
                        <td>@($"{values[0]:F2}")</td>
                        <td>@($"{values[1]:F2}")</td>
                        <td>@($"{values[2]:F2}")</td>
                        <td>@($"{values[3]:F2}")</td>
                        <td>@($"{values[4]:F2}")</td>
                        <td>@($"{values[5]:F2}")</td>
                    </tr>
                }
            </table>
        </div>
        
        </div>
        
    </div>

    <SKGLView 
        EnableRenderLoop=true
        OnPaintSurface="PaintAgentActionView" 
        style=@($"width: {AgentViewWidth}px; height: {AgentViewHeight}px")
        width=@AgentViewWidth
        height=@AgentViewHeight
        />

    <SKGLView 
        EnableRenderLoop=true 
        OnPaintSurface="PaintMainView"
        style=@($"width: {MainViewWidth}px; height: {MainViewHeight}px; grid-column: 2; grid-row: 2/4")
        width=@MainViewWidth
        height=@MainViewHeight

            

        tabindex="0"

        @onmousemove="OnMouseEvent"
        @onmousedown="OnMouseEvent"
        @onmouseup="OnMouseEvent"
        @onclick="OnMouseClick"
        @onmouseout="OnMouseOut"
        @onmousewheel="OnMouseWheel"
        @onkeydown="OnKeyDown"
        @onkeyup="OnKeyUp"/>
</div>
